.script_exec: &script_exec |
  [[ "$TRACE" ]] && set -x

    function helm2to3() {
       echo "Helm 3 antes de migrar"
       helm3 ls -A
       echo " Moviendo las configuraciones de helm2 a helm3"
       helm3 2to3 move config
       echo " Se migrarán los siguientes charts a v3"
       while IFS=, read col1
       do
        echo ${col1}
        echo y | helm3 2to3 convert ${col1} --delete-v2-releases
       done < chart
       echo y | helm3 2to3 cleanup
       
       echo "Helm 3 después de migrar"
       helm3 ls -A
    }

stages:
  - helm2_install
  - helm_v2_to_v3

image: jonathantorres/helm2nkube:0.2

helm2_install:
  stage: helm2_install
  before_script: 
    - *script_exec  
    - gcloud auth activate-service-account --key-file=$testKey --project=$CLOUDSDK_CORE_PROJECT
    - gcloud container clusters get-credentials $CLUSTER --zone southamerica-east1-c --project $CLOUDSDK_CORE_PROJECT
  script:
    - echo "Instalando Helm V2"
    - sh helm-install.sh
    - helm list --short > chart
  tags:
    - docker
  except:
    variables:
      - $DISABLE_HELM2_INSTALL == "true"
  artifacts:
    paths:
      - chart

pre_verification:
  stage: helm_v2_to_v3
  before_script:
    - gcloud auth activate-service-account --key-file=$testKey --project=$CLOUDSDK_CORE_PROJECT
    - gcloud container clusters get-credentials $CLUSTER --zone southamerica-east1-c --project $CLOUDSDK_CORE_PROJECT
  script:
    - echo "Estado de helm V2 antes de migrar"
    - helm version
    - kubectl get po -A | grep tiller || true
    
helm_v2_to_v3:
  image: jonathantorres/hello-helm3:0.2
  stage: helm_v2_to_v3
  before_script: 
    - *script_exec 
    - gcloud auth activate-service-account --key-file=$testKey --project=$CLOUDSDK_CORE_PROJECT
    - gcloud container clusters get-credentials $CLUSTER --zone southamerica-east1-c --project $CLOUDSDK_CORE_PROJECT
  script:
    - helm2to3
  tags:
    - docker
      
post_verification:
  stage: helm_v2_to_v3
  before_script:
    - gcloud auth activate-service-account --key-file=$testKey --project=$CLOUDSDK_CORE_PROJECT
    - gcloud container clusters get-credentials $CLUSTER --zone southamerica-east1-c --project $CLOUDSDK_CORE_PROJECT
  script:
    - echo "Estado de helm V2 despues de migrar"
    - helm version
    - kubectl get po -A | grep tiller || true